package ru.dbotthepony.mc.otm.container

import net.minecraft.world.item.ItemStack
import ru.dbotthepony.kommons.collect.any

/**
 * Skeletal implementation for containers which revolve around [IContainerSlot]
 */
interface ISlottedContainer<out S : IContainerSlot> : IEnhancedContainer<S> {
	override fun setChanged(slot: Int) {
		containerSlot(slot).setChanged()
	}

	override fun getMaxStackSize(slot: Int, itemStack: ItemStack): Int {
		return containerSlot(slot).maxStackSize(itemStack)
	}

	override fun getItem(slot: Int): ItemStack {
		return containerSlot(slot).item
	}

	override fun removeItem(slot: Int, amount: Int): ItemStack {
		return containerSlot(slot).remove(amount)
	}

	override fun removeItemNoUpdate(slot: Int): ItemStack {
		return containerSlot(slot).remove()
	}

	override fun setItem(slot: Int, itemStack: ItemStack) {
		containerSlot(slot).item = itemStack
	}

	override val hasFilterableSlots: Boolean
		get() = slotIterator().any { it is IFilteredContainerSlot }
}
